<?php
/**
* @Copyright Copyright (C) 2019 Martin Maetz
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.plugin.plugin');

class plgContentMK19VideoJSplus extends JPlugin {
	
	public function onContentPrepare($context, &$article, &$params, $limitstart) {
		
		$app = JFactory::getApplication();
		
	  	$pluginParams = $this->params;
	
		if (!isset($GLOBALS['plg_mk19videojsplus'])) {
			$GLOBALS['plg_mk19videojsplus'] = 1;
		}
	
		$hits = preg_match_all('#{mk19videojsplus\s*(.*?)}#s', $article->text, $matches);
		
		if (!empty($hits)) {
			$document = JFactory::getDocument();

			if ($pluginParams->get('self_host') == "0") {
				$document->addStyleSheet(JURI::base().'plugins/content/mk19videojsplus/video-js/video-js.min.css');
				$document->addScript(JURI::base().'plugins/content/mk19videojsplus/video-js/video.min.js');
				$document->addScriptDeclaration('
					_V_.options.flash.swf = "'.JURI::base().'plugins/content/mk19videojsplus/video-js/video-js.swf";
					');
			} elseif ($pluginParams->get('self_host') == "1") {
				$document->addStyleSheet('https://vjs.zencdn.net/c/video-js.css');
				$document->addScript('https://vjs.zencdn.net/c/video.js');
			} elseif ($pluginParams->get('self_host') == "2") {
				$document->addStyleSheet('https://vjs.zencdn.net/5.12.6/video-js.css');
				$document->addScript('https://vjs.zencdn.net/5.12.6/video.js');
				$document->addScript('https://vjs.zencdn.net/ie8/1.1.2/videojs-ie8.min.js');
				//overlay
				if ($pluginParams->get('overlay') == "1") {
					$document->addStyleSheet('//players.brightcove.net/videojs-overlay/1/videojs-overlay.css');
					$document->addScript('//players.brightcove.net/videojs-overlay/1/videojs-overlay.min.js');
				}
				//overlay ima
				if ($pluginParams->get('ima') == "1") {
					$document->addStyleSheet(JURI::base().'plugins/content/mk19videojsplus/videojs-ima/src/videojs.ima.css');
					$document->addStyleSheet(JURI::base().'plugins/content/mk19videojsplus/videojs-ima/style.css');
					//$document->addScript('//imasdk.googleapis.com/js/sdkloader/ima3.js');
					$document->addScript(JURI::base().'plugins/content/mk19videojsplus/videojs-ima/src/videojs.ima.js');
					//ads
					$document->addStyleSheet(JURI::base().'plugins/content/mk19videojsplus/videojs-ads/videojs.ads.css');
					$document->addScript(JURI::base().'plugins/content/mk19videojsplus/videojs-ads/videojs.ads.js');
				}
			} elseif ($pluginParams->get('self_host') == "3") {
				$document->addStyleSheet('https://vjs.zencdn.net/6.2.8/video-js.css');
				$document->addScript('https://vjs.zencdn.net/6.2.8/video.js');
				$document->addScript('https://vjs.zencdn.net/ie8/1.1.2/videojs-ie8.min.js');
				//overlay
				if ($pluginParams->get('overlay') == "1") {
					$document->addStyleSheet('//players.brightcove.net/videojs-overlay/1/videojs-overlay.css');
					$document->addScript('//players.brightcove.net/videojs-overlay/1/videojs-overlay.min.js');
				}
				//overlay ima
				if ($pluginParams->get('ima') == "1") {
					$document->addStyleSheet(JURI::base().'plugins/content/mk19videojsplus/videojs-ima/src/videojs.ima.css');
					$document->addStyleSheet(JURI::base().'plugins/content/mk19videojsplus/videojs-ima/style.css');
					//$document->addScript('//imasdk.googleapis.com/js/sdkloader/ima3.js');
					$document->addScript(JURI::base().'plugins/content/mk19videojsplus/videojs-ima/src/videojs.ima.js');
					//ads
					$document->addStyleSheet(JURI::base().'plugins/content/mk19videojsplus/videojs-ads/videojs.ads.css');
					$document->addScript(JURI::base().'plugins/content/mk19videojsplus/videojs-ads/videojs.ads.js');
				}
			} elseif ($pluginParams->get('self_host') == "4") {
				$document->addStyleSheet('https://vjs.zencdn.net/7.4.1/video-js.css');
				$document->addScript('https://vjs.zencdn.net/7.4.1/video.js');
				$document->addScript('https://vjs.zencdn.net/ie8/ie8-version/videojs-ie8.min.js');
				//overlay
				if ($pluginParams->get('overlay') == "1") {
					$document->addStyleSheet('//players.brightcove.net/videojs-overlay/1/videojs-overlay.css');
					$document->addScript('//players.brightcove.net/videojs-overlay/1/videojs-overlay.min.js');
				}
				//overlay ima
				if ($pluginParams->get('ima') == "1") {
					$document->addStyleSheet(JURI::base().'plugins/content/mk19videojsplus/videojs-ima/src/videojs.ima.css');
					$document->addStyleSheet(JURI::base().'plugins/content/mk19videojsplus/videojs-ima/style.css');
					//$document->addScript('//imasdk.googleapis.com/js/sdkloader/ima3.js');
					$document->addScript(JURI::base().'plugins/content/mk19videojsplus/videojs-ima/src/videojs.ima.js');
					//ads
					$document->addStyleSheet(JURI::base().'plugins/content/mk19videojsplus/videojs-ads/videojs.ads.css');
					$document->addScript(JURI::base().'plugins/content/mk19videojsplus/videojs-ads/videojs.ads.js');
				}
			}
			
			if ($pluginParams->get('self_host') == "0" || $pluginParams->get('self_host') == "1") {
			$document->addStyleDeclaration('
			.videoWrapper {
				position: relative;
				padding-top: 0px;
				height: 0;
				z-index: 1000;
				overflow: hidden;
			}
			video {
				position: absolute !important;
				top: 0;
				left: 0;
				width: 100% !important;
				height: 100% !important;
				z-index: 1;
			}
			video.video-js {
				z-index: 1000;
			}
			.video-js .vjs-controls {
				z-index: 1002;
			}
			.video-js .vjs-big-play-button {
				z-index: 1002;
			}
			.videoWrapper .video-js {
				position: absolute;
				top: 0;
				left: 0;
				width: 100% !important;
				height: 100% !important;
				z-index: 1;
				background: #000000;
			}
			.videoWrapper object,
			.videoWrapper embed {
				position: absolute;
				top: 0;
				left: 0;
				width: 100%;
				height: 100% !important;
				z-index: 1;
			}
			.vjs-spinner {
			  /*display: none !important;*/
			}
			.video-js img.vjs-poster {
				height: 100% !important;
				width: 100% !important;
				max-width: 100%;
				z-index: 1;
			}');
			} elseif ($pluginParams->get('self_host') == "2" || $pluginParams->get('self_host') == "3" || $pluginParams->get('self_host') == "4") {
			$document->addStyleDeclaration('
			.videoWrapper {
				position: relative;
				padding-top: 0px;
				height: 0;
				z-index: 1000;
				overflow: hidden;
			}
			/*video {
				position: absolute !important;
				top: 0;
				left: 0;
				width: 100% !important;
				height: 100% !important;
				z-index: 1;
			}*/
			video.video-js {
				z-index: 1000;
			}
			/*.video-js .vjs-controls {
				z-index: 1002;
			}*/
			/*.video-js .vjs-big-play-button {
				z-index: 1002;
				top: 35% !important;
				left: 35% !important;
			}*/
			.videoWrapper .video-js {
				position: absolute;
				top: 0;
				left: 0;
				width: 100% !important;
				height: 100% !important;
				z-index: 1;
				background: #000000;
			}
			.videoWrapper object,
			.videoWrapper embed {
				position: absolute;
				top: 0;
				left: 0;
				width: 100%;
				height: 100% !important;
				z-index: 1;
			}
			.vjs-spinner {
			  /*display: none !important;*/
			}
			.video-js img.vjs-poster {
				height: 100% !important;
				width: 100% !important;
				max-width: 100%;
				z-index: 1;
			}
			
			/*for overlay*/
			/*.video-js .vjs-overlay{color:#fff;position:absolute;text-align:center}
			.video-js .vjs-overlay-no-background{max-width:33%}*/
			.video-js .vjs-overlay-background{
				background-color:#000000;
				background-color:rgba(0,0,0,0.4	);
				border-radius:3px;
				padding:10px;
				width:auto;
			}
			/*.video-js .vjs-overlay-top-left{top:5px;left:5px}
			.video-js .vjs-overlay-top{left:50%;margin-left:-16.5%;top:5px}
			.video-js .vjs-overlay-top-right{right:5px;top:5px}
			.video-js .vjs-overlay-right{margin-top:-15px;right:5px;top:50%}
			.video-js .vjs-overlay-bottom-right{bottom:3.5em;right:5px}
			.video-js .vjs-overlay-bottom{bottom:3.5em;left:50%;margin-left:-16.5%}
			.video-js .vjs-overlay-bottom-left{bottom:3.5em;left:5px}
			.video-js .vjs-overlay-left{left:5px;margin-top:-15px;top:50%}*/
			.video-js .vjs-overlay-center{
				left:10px;
				top:30%;
			}
			
			');
			}
			
			if ($pluginParams->get('self_host') == "2" || $pluginParams->get('self_host') == "3" || $pluginParams->get('self_host') == "4") {
			$document->addStyleDeclaration('
			.video-js .vjs-big-play-button {
				z-index: 1002;
				top: 40% !important;
				left: 40% !important;
				width: 2em;
			}
			');
			}
			
			
			for ($i=$GLOBALS['plg_mk19videojsplus']; $i<$GLOBALS['plg_mk19videojsplus']+$hits; $i++) {

				for ($j=0; $j<$hits; $j++) {
					$videoParams = $matches[1][$j];
					$videoParamsList = $this->contentMK19VideoJSPlus_getParams($videoParams, $pluginParams);
					$html = $this->contentMK19VideoJSPlus_createHTML($i+$j, $pluginParams, $videoParamsList);
					$pattern = str_replace('[', '\[', $matches[0][$j]);
					$pattern = str_replace(']', '\]', $pattern);
					$pattern = str_replace('/', '\/', $pattern);
					$pattern = str_replace('|', '\|', $pattern);
			    	$article->text = preg_replace('/'.$pattern.'/', $html, $article->text, 1);
				}

			}
			
			// Count instances
			$GLOBALS['plg_mk19videojsplus'] += $hits;
		
		} else {
			return false;
		}

		return true;
		
	}
	
	protected function contentMK19VideoJSPlus_getParams($videoParams, $pluginParams) {

		$videoParamsList['margin'] 				= $pluginParams->get('margin');
		$videoParamsList['align'] 				= $pluginParams->get('align');
		$videoParamsList['width'] 				= $pluginParams->get('width');
		$videoParamsList['height'] 				= $pluginParams->get('height');
		$videoParamsList['controls']			= $pluginParams->get('controls');
		$videoParamsList['autoplay']			= $pluginParams->get('autoplay');
		$videoParamsList['preload']				= $pluginParams->get('preload');
		$videoParamsList['loop']				= $pluginParams->get('loop');
		$videoParamsList['poster_visibility']	= $pluginParams->get('poster_visibility');
		$videoParamsList['video_mp4']			= '';
		$videoParamsList['video_webm']			= '';
		$videoParamsList['video_ogg']			= '';
		$videoParamsList['poster']				= '';
		$videoParamsList['text_track']			= '';
		$videoParamsList['subtitles']			= '';
		$videoParamsList['ima'] 				= $pluginParams->get('ima');
		$videoParamsList['imajs'] 				= $pluginParams->get('imajs');
		$videoParamsList['overlay'] 				= $pluginParams->get('overlay');
		$videoParamsList['overlayjs'] 				= $pluginParams->get('overlayjs');

		$items = explode(' ', $videoParams);
		
		foreach ($items as $item) {
			if ($item != '') {
				$item	= explode('=', $item);
				$name 	= $item[0];
				$value	= strtr($item[1], array('['=>'', ']'=>''));
				/*if ($name == "text_track") {
					//$videoParamsList[$name][] = $value;
					$videoParamsList[$name] = $value;
				} else {
					$videoParamsList[$name] = $value;
				}*/
				$videoParamsList[$name] = $value;
			}
		}
		
		return $videoParamsList;
	}
	
	protected function contentMK19VideoJSPlus_createHTML($id, &$pluginParams, &$videoParamsList) {
		
		$margin 				= $videoParamsList['margin'];
		$align 				= $videoParamsList['align'];
		$width 				= $videoParamsList['width'];
		$height 			= $videoParamsList['height'];
		$controls			= $videoParamsList['controls'];
		$autoplay			= $videoParamsList['autoplay'];
		$preload			= $videoParamsList['preload'];
		$loop				= $videoParamsList['loop'];
		$poster_visibility	= $videoParamsList['poster_visibility'];
		$video_mp4			= $videoParamsList['video_mp4'];
		$video_webm			= $videoParamsList['video_webm'];
		$video_ogg			= $videoParamsList['video_ogg'];
		$poster				= $videoParamsList['poster'];
		$tracks				= $videoParamsList['text_track'];
		$subtitles				= $videoParamsList['subtitles'];
		$ratio				= ($height/$width)*100;
		$ima 				= $videoParamsList['ima'];
		$imajs 				= $videoParamsList['imajs'];
		$overlay 				= $videoParamsList['overlay'];
		$overlayjs 				= $videoParamsList['overlayjs'];

		// Controls
		if ($controls == "1") {
			$controls_html 	= ' controls="controls"';
		} else {
			$controls_html 	= '';
		}
		
		// Autoplay
		if ($autoplay == "1") {
			$autoplay_html 	= ' autoplay="autoplay"';
		} else {
			$autoplay_html 	= '';
		}

		// Preload
		if ($preload == "auto" || $preload == "metadata" || $preload == "none") {
			//$preload_html 	= ' preload="'.$preload.'"';
			$preload_html 	= ' preload="'.$preload;
		}

		// Loop
		if ($loop == "1") {
			$loop_html		= ' loop="loop"';
		} else {
			$loop_html 		= '';
		}

		// Poster image
		if ($poster_visibility == "1" && $poster != "") {
			$poster_html 	= ' poster="'.$poster;
		} else {
			$poster_html 	= '';
		}
		
		// Text tracks
		/*if (!empty($tracks)) {
			$text_track_html = '';
			foreach ($tracks AS $track) {
				$track_items = explode('|', $track);
				$text_track_html .= '<track kind="'.$track_items[0].'" src="'.$track_items[1].'" srclang="'.$track_items[2].'" label="'.$track_items[3].'" />';			
			}	
		} else {
			$text_track_html = '';
		}*/
		/*if (!empty($tracks)) {
			$text_track_html = '';
			//foreach ($tracks AS $track) {
				$track_items = explode('|', $tracks);
				$text_track_html .= '<track kind="'.$track_items[0].'" src="'.$track_items[1].'" srclang="'.$track_items[2].'" label="'.$track_items[3].'" />';			
			//}	
		} else {
			$text_track_html = '';
		}*/
		
		if (!empty($tracks)) {
			$text_track_html = '';
			$track_items = explode('|', $tracks);
			$i = 0;
			$imax = count($track_items);
			while ($i <= $imax):
				$text_track_html .= '<track kind="'.$track_items[$i].'" src="'.$track_items[$i+1].'" srclang="'.$track_items[$i+2].'" label="'.$track_items[$i+3].'" />';			
				$itemcount = $i + 4;
				$i = $itemcount;
			endwhile;	
		} else {
			$text_track_html = '';
		}

		
		// Video align
		if ($align == "center") {
			$align_style = 'margin: 0 auto;';
		} elseif ($align == "left") {
			$align_style = 'margin: 0 auto 0 0;';
		} elseif ($align == "right") {
			$align_style = 'margin: 0 0 0 auto;';
		}
		
		// HTML output
		$html = '';
		
		$html = '<div class="videoContainer_'.$id.'" style="width: 100%;margin: '.$margin.';padding: 0;">';
		
		$html .= '<div class="videoSizer_'.$id.'" style="'.$align_style.'"><div class="videoWrapper_'.$id.' videoWrapper" id="videoWrapper_'.$id.'">';
		
		//$html .= '<div id="'.$id.'_adContainer" class="'.$id.'_adContainer" style="position: absolute; top: 0px; left: 0px; width: 100%; height: 100%;background:#ccc;"></div>';

		if ($pluginParams->get('self_host') == "0" || $pluginParams->get('self_host') == "1") {
			$html .= '<video id="plg_mk19videojsplus_'.$id.'" class="video-js vjs-default-skin"'.$controls_html.$autoplay_html.$preload_html.$loop_html.$poster_html.'" data-setup="{}">';
		} elseif ($pluginParams->get('self_host') == "2" || $pluginParams->get('self_host') == "3" || $pluginParams->get('self_host') == "4") {
			$html .= '<video id="plg_mk19videojsplus_'.$id.'" class="video-js"'.$controls_html.$autoplay_html.$preload_html.$loop_html.$poster_html.'" data-setup="{}">';
		}

		if (!empty($video_mp4)) {
			$html .= '<source src="'.$video_mp4.'" type="video/mp4" />';
		}

		if (!empty($video_webm)) {
			$html .= '<source src="'.$video_webm.'" type="video/webm" />';
		}

		if (!empty($video_ogg)) {
			$html .= '<source src="'.$video_ogg.'" type="video/ogg" />';
		}
		
		$html .= $text_track_html;
		
		if ($pluginParams->get('self_host') == "2" || $pluginParams->get('self_host') == "3" || $pluginParams->get('self_host') == "4") {
			$html .= '<p class="vjs-no-js">To view this video please enable JavaScript, and consider upgrading to a web browser that <a href="https://videojs.com/html5-video-support/" target="_blank">supports HTML5 video</a></p>';
		}

		$html .= '</video>';
		
		if ($ima == "1" && empty($imajs)) {
			$html .= '<script src="https://imasdk.googleapis.com/js/sdkloader/ima3.js" type="text/javascript"></script>';
			$html .= '<script src="'.JURI::base().'plugins/content/mk19videojsplus/videojs-ima/js/ads.js" type="text/javascript"></script>';
			//$html .= '<div id="'.$id.'_adContainer" class="'.$id.'_adContainer" style="position: absolute; top: 0px; left: 0px; width: 512%; height: 296;"></div>';
		} elseif ($ima == "1" && !empty($imajs)) {
			$html .= '<script src="https://imasdk.googleapis.com/js/sdkloader/ima3.js" type="text/javascript"></script>';
			$html .= '<script id="pageScriptima" type="text/javascript">';
			$html .= $imajs;
			$html .= '</script>';
		}
		
		if ($overlay == "1" && empty($overlayjs)) {
			$html .= '<script src="'.JURI::base().'plugins/content/mk19videojsplus/videojs-overlay/overlay.js" type="text/javascript"></script>';
			//$html .= '<div id="'.$id.'_adContainer" class="'.$id.'_adContainer" style="position: absolute; top: 0px; left: 0px; width: 512%; height: 296;"></div>';
		} elseif ($overlay == "1" && !empty($overlayjs)) {
			$html .= '<script id="pageScriptoverlay" type="text/javascript">';
			$html .= $overlayjs;
			$html .= '</script>';
		}
		
		$html .= '</div></div></div>';
		
		$html .= '<style type="text/css">
		.videoSizer_'.$id.' { max-width: '.$width.'px; }
		.videoWrapper_'.$id.' { padding-bottom: '.$ratio.'%; }
		</style>';
		
		
		return $html;

	}
	
}